# membercontrol v1.0 by team-perplex
# blowcrypt code by poci/ppx
#
# provides a dynamic and searchable memberlist for your group.
#
# install:
# --------
#
# 1. put this script into your eggdrop.conf
# 2. create an empty textfile
#    $mc(file) should be pointing to it
# 3. rehash your bot
#
# changelog:
# ----------
#
# - membercontrol v1.0
#
# initial release.
#
# todo:
# -----
#
# - dcc transfer of memberlist
# - temp. memberlist reformatting for dcc transfer
#
# commands:
# ---------
#
# !mc [add/del/jobs/search/membername/help] ...
#
# !mc add <name>              - adds a member to the db
# !mc del <name>              - deletes a member from the db
# !mc jobs <name> <jobs>      - changes the jobs for <name>
# !mc search <wildcard>       - search in the db
# !mc <name>                  - shows the jobs for <name>
# !mc help                    - shows a command overview via PRIVMSG
#
#
#
# stay tuned for upcoming versions.
#
## config:

# set this to your group-chan
set mc(chan) "#perplex"
#e
# set this to your group-name
# uppercase looks better;)
set mc(group) "PERPLEX"

# path to you logfile
set mc(file) "/home/hawk/eggdrop/members.txt"

# path for logfile backup
set mc(backup) "/home/hawk/eggdrop/sites.txt.bak"

# set to 1 for blowcrypt, 0 for plaintext
set mc(blow) 0

# enter your blowfishkey below if $mc(blow) is set to 1
# dont forget to change the chan
set mcblowkey(#perplex) ""

# config done.
# dont mess with anything below this line.
#
#########################################################

set mc(ver) "V1.0"

bind pub - !mc mcproc
bind pub - +OK mcencryptedincominghandler

proc mcproc {nick host hand chan arg} {
	global mc
	if {[string tolower $chan] != [string tolower $mc(chan)]} {return}
	if {$mc(blow) == 0} {
		if {[lindex $arg 0] == ""} {
			putserv "PRIVMSG $chan :\002error\002: try !mc help"
			return
		}
	} else {
		if {[lindex $arg 0] == ""} {
			mcputblow "PRIVMSG $chan :\002error\002: try !mc help"
			return
		}
	}
	if {[lindex $arg 0] == "help"} {
		if {$mc(blow) == 0} {
			putserv "PRIVMSG $chan :help request by $nick ..."
			putserv "PRIVMSG $nick :$mc(group) MEMBERCONTROL $mc(ver) - PERPLEX DEVELOPMENT 2004"
			putserv "PRIVMSG $nick :---------------------------------------------------------------------------"
			putserv "PRIVMSG $nick :!mc add <name>              - adds a member to the db"
			putserv "PRIVMSG $nick :!mc del <name>              - deletes a member from the db"
			putserv "PRIVMSG $nick :!mc jobs <name> <jobs>      - changes the jobs for <name>"
			putserv "PRIVMSG $nick :!mc search <wildcard>       - search in the db"
			putserv "PRIVMSG $nick :!mc <name>                  - shows the jobs for <name>"
			putserv "PRIVMSG $nick :!mc help                    - shows a this help text"
		} else {
			mcputblow "PRIVMSG $chan :help request by $nick ..."
			putserv "PRIVMSG $nick :$mc(group) MEMBERCONTROL $mc(ver) - PERPLEX DEVELOPMENT 2004"
			putserv "PRIVMSG $nick :---------------------------------------------------------------------------"
			putserv "PRIVMSG $nick :!mc add <name>              - adds a member to the db"
			putserv "PRIVMSG $nick :!mc del <name>              - deletes a member from the db"
			putserv "PRIVMSG $nick :!mc jobs <name> <jobs>      - changes the jobs for <name>"
			putserv "PRIVMSG $nick :!mc search <wildcard>       - search in the db"
			putserv "PRIVMSG $nick :!mc <name>                  - shows the jobs for <name>"
			putserv "PRIVMSG $nick :!mc help                    - shows a this help text"
		}
		return
	}
	if {[lindex $arg 0] == "add"} {
		if {$mc(blow) == 0} {
			if {[lindex $arg 1] == ""} {
				putserv "PRIVMSG $chan :\002error\002: specify a member name."
				return
			}
		} else {
			if {[lindex $arg 1] == ""} {
				mcputblow "PRIVMSG $chan :\002error\002: specify a member name."
				return
			}
		}
		set fp [open $mc(file) r]
		while {![eof $fp]} {
			gets $fp line
			if {[string tolower [lindex $line 0]] == [string tolower [lindex $arg 1]]} {
				if {$mc(blow) == 0} {
					putserv "PRIVMSG $chan :\002error\002: member \002[lindex $arg 1]\002 is already added."
				} else {
					mcputblow "PRIVMSG $chan :\002error\002: member \002[lindex $arg 1]\002 is already added."
				}
				close $fp
				return
			}
		}
		close $fp
		set fp [open $mc(file) a+]
		puts $fp "\{[lindex $arg 1]\} \{\} \{\} \{\} \{\} \{\} \{\} \{\} \{\} \{\} \{\} \{\} \{\} \{\} \{\} \{\} \{\}"
		close $fp
		if {$mc(blow) == 0} {
			putserv "PRIVMSG $chan :member \002[lindex $arg 1]\002 successfully added to database."
			return
		} else {
			mcputblow "PRIVMSG $chan :member \002[lindex $arg 1]\002 successfully added to database."
			return
		}
		return
	}
	if {[lindex $arg 0] == "del"} {
		if {$mc(blow) == 0} {
			if {[lindex $arg 1] == ""} {
				putserv "PRIVMSG $chan :\002error\002: specify a member name."
				return
			}
		} else {
			if {[lindex $arg 1] == ""} {
				mcputblow "PRIVMSG $chan :\002error\002: specify a member name."
				return
			}
		}
		if {[file exist $mc(file)] == 0} {
			if {$mc(blow) == 0} {
				putserv "PRIVMSG $chan :\002error\002: logfile not found or no members added."
			} else {
				mcputblow "PRIVMSG $chan :\002error\002: logfile not found or no members added."
			}
			return
		}
		set deleted 0
		exec mv -f $mc(file) $mc(backup)
		set oldlog [open $mc(backup) r]
		set newlog [open $mc(file) a]
		while {![eof $oldlog]} {
			gets $oldlog line
			if {[string tolower [lindex $line 0]] != [string tolower [lindex $arg 1]] && $line != ""} {
				puts $newlog $line
			} else {
				if {$line != ""} {set deleted 1}
			}
		}
		close $oldlog
		close $newlog
		if {$mc(blow) == 0} {
			if {$deleted == 1} {
				putserv "PRIVMSG $chan :members \002[lindex $arg end]\002 successfully deleted."
			} else {
				putserv "PRIVMSG $chan :\002error\002: member not found in db."
			}
		} else {
			if {$deleted == 1} {
				mcputblow "PRIVMSG $chan :member \002[lindex $arg end]\002 successfully deleted."
			} else {
				mcputblow "PRIVMSG $chan :\002error\002: member not found in db."
			}
		}
		return
	}
	if {[lindex $arg 0] == "jobs"} {
		if {$mc(blow) == 0} {
			if {[lindex $arg 1] == ""} {
				putserv "PRIVMSG $chan :\002error\002: specify a member name."
				return
			}
		} else {
			if {[lindex $arg 1] == ""} {
				mcputblow "PRIVMSG $chan :\002error\002: specify a member name."
				return
			}
		}
		if {$mc(blow) == 0} {
			if {[lindex $arg 2] == ""} {
				putserv "PRIVMSG $chan :\002error\002: specify at least one job for \002[lindex $arg 1]\002."
				return
			}
		} else {
			if {[lindex $arg 2] == ""} {
				mcputblow "PRIVMSG $chan :\002error\002: specify at least one job for \002[lindex $arg 1]\002."
				return
			}
		}
		set changed 0
		exec mv -f $mc(file) $mc(backup)
		set oldlog [open $mc(backup) r]
		set newlog [open $mc(file) a]
		while {![eof $oldlog]} {
			gets $oldlog line
			if {[string tolower [lindex $line 0]] == [string tolower [lindex $arg 1]] && $line != ""} {
				set line [lreplace $line 1 1 [lrange $arg 2 end]]
				set changed 1
				puts $newlog $line
			} else {
				puts $newlog $line
			}
		}
		close $oldlog
		close $newlog
		if {$mc(blow) == 0} {
			if {$changed == 1} {
				putserv "PRIVMSG $chan :jobs for \002[lindex $arg 1]\002 successfully changed."
			} else {
				putserv "PRIVMSG $chan :\002error\002: member not found in db."
			}
		} else {
			if {$changed == 1} {
				mcputblow "PRIVMSG $chan :jobs for \002[lindex $arg 1]\002 successfully changed."
			} else {
				mcputblow "PRIVMSG $chan :\002error\002: member not found in db."
			}
		}
		return
	}
	if {[lindex $arg 0] == "search"} {
		if {$mc(blow) == 0} {
			if {[lindex $arg 1] == ""} {
				putserv "PRIVMSG $chan :\002error\002: no wildcard gived."
				return
			}
		} else {
			if {[lindex $arg 1] == ""} {
				mcputblow "PRIVMSG $chan :\002error\002: no wildcard gived."
				return
			}
		}
		set memnum 0
		set jobnum 0
		set members ""
		set jobs ""
		set fp [open $mc(file) r]
		while {![eof $fp]} {
			gets $fp line
			# checking for members matching wildcard
			if {$line != "" && [string match *[string toupper [lindex $arg 1]]* [string toupper [lindex $line 0]]]} {
				incr memnum
				set members "$members [lindex $line 0],"
			}
			# checking for jobs
			if {$line != "" && [string match *[string toupper [lindex $arg 1]]* [string toupper [lindex $line 1]]]} {
				incr jobnum
				set jobs "$jobs [lindex $line 0],"
			}
		}
		if {$memnum == 0} {
			if {$mc(blow) == 0} {
				putserv "PRIVMSG $chan :matching members: none."
			} else {
				mcputblow "PRIVMSG $chan :matching members: none."
			}
		} else {
			if {$mc(blow) == 0} {
				putserv "PRIVMSG $chan :matching members: $members total of $memnum matches."
			} else {
				mcputblow "PRIVMSG $chan :matching members: $members total of $memnum matches."
			}
		}
		if {$jobnum == 0} {
			if {$mc(blow) == 0} {
				putserv "PRIVMSG $chan :members for matching jobs: none."
			} else {
				mcputblow "PRIVMSG $chan :members for matching jobs: none."
			}
		} else {
			if {$mc(blow) == 0} {
				putserv "PRIVMSG $chan :members for matching jobs: $jobs total of $jobnum matches."
			} else {
				mcputblow "PRIVMSG $chan :members for matching jobs: $jobs total of $jobnum matches."
			}
		}
		return
	}
	set fp [open $mc(file) r+]
	while {![eof $fp]} {
		gets $fp line
		if {[string tolower [lindex $line 0]] == [string tolower [lindex $arg 0]]} {
			if {$mc(blow) == 0} {
				putserv "PRIVMSG $chan :\002[lindex $arg 0]\002: [lindex $line 1]"
			} else {
				mcputblow "PRIVMSG $chan :\002[lindex $arg 0]\002: [lindex $line 1]"
			}
		close $fp
		return
		}
	}
	if {$mc(blow) == 0} {
		putserv "PRIVMSG $chan :\002error\002: member not found."
	} else {
		mcputblow "PRIVMSG $chan :\002error\002: member not found."
	}
	close $fp
	return
}


# blowfish part beginning (code by poci)

proc mcputblow {text {option ""}} {
	global mcblowkey
	if {$option==""} {
		if {[lindex $text 0]=="PRIVMSG" && [info exists mcblowkey([string tolower [lindex $text 1]])]} {
			putserv "PRIVMSG [lindex $text 1] :+OK [encrypt $mcblowkey([string tolower [lindex $text 1]]) [string trimleft [join [lrange $text 2 end]] :]]"
		} else {
			putserv $text
		}
	} else {
	  	if {[lindex $text 0]=="PRIVMSG" && [info exists mcblowkey([string tolower [lindex $text 1]])]} {
			putserv "PRIVMSG [lindex $text 1] :+OK [encrypt $mcblowkey([string tolower [lindex $text 1]]) [string trimleft [join [lrange $text 2 end]] :]]" $option
		} else {
			putserv $text $option
		}
	}
}

proc mcencryptedincominghandler {nick host hand chan arg} {
	global mcblowkey mc
	if {![info exists mcblowkey([string tolower $chan])]} {return}
	set tmp [decrypt $mcblowkey([string tolower $chan]) $arg]
	foreach item [binds pub] {
		if {[lindex $item 2]=="+OK"} {continue}
		if {[lindex $item 1]!="-|-"} {
			if {![matchattr $hand [lindex $item 1] $chan]} {continue}
		}
		if {[lindex $item 2]==[lindex $tmp 0]} {[lindex $item 4] $nick $host $hand $chan [lrange $tmp 1 end]}
	 }
}

putlog "PERPLEX SITE LIST $mc(ver) LOADED - CODE BY TEAM-PERPLEX 2005"
